'use strict';

exports.__esModule = true;
exports.DIRECTIONS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var DIRECTIONS = exports.DIRECTIONS = {
  up: 'column-reverse',
  down: 'column',
  left: 'row-reverse',
  right: 'row'
};

var StyledUl = (0, _styledComponents2.default)('ul')(function (_ref) {
  var direction = _ref.direction;
  return {
    display: 'flex',
    width: 'fit-content',
    listStyle: 'none',
    margin: '0',
    padding: '0',
    flexDirection: DIRECTIONS[direction],
    justifyContent: 'center',
    alignItems: 'center'
  };
});

var FloatingMenu = function FloatingMenu(_ref2) {
  var _ref2$slideSpeed = _ref2.slideSpeed,
      slideSpeed = _ref2$slideSpeed === undefined ? 500 : _ref2$slideSpeed,
      _ref2$direction = _ref2.direction,
      direction = _ref2$direction === undefined ? 'down' : _ref2$direction,
      className = _ref2.className,
      _ref2$isOpen = _ref2.isOpen,
      isOpen = _ref2$isOpen === undefined ? false : _ref2$isOpen,
      _ref2$spacing = _ref2.spacing,
      spacing = _ref2$spacing === undefined ? 8 : _ref2$spacing,
      children = _ref2.children,
      rest = _objectWithoutProperties(_ref2, ['slideSpeed', 'direction', 'className', 'isOpen', 'spacing', 'children']);

  var childrenWithProps = _react2.default.Children.map(children, function (child, index) {
    return _react2.default.cloneElement(child, {
      isOpen: isOpen,
      slideSpeed: slideSpeed,
      direction: direction,
      index: index,
      spacing: spacing
    });
  });

  return _react2.default.createElement(
    StyledUl,
    _extends({
      className: className,
      direction: direction
    }, rest),
    childrenWithProps
  );
};

FloatingMenu.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.arrayOf(_propTypes2.default.element).isRequired,
  slideSpeed: _propTypes2.default.number,
  spacing: _propTypes2.default.number,
  direction: _propTypes2.default.string,
  isOpen: _propTypes2.default.bool
};

exports.default = FloatingMenu;